#pragma once
#include <comdef.h>
#include "StringUtil.h"

using namespace std;

#define ThrowIfFailed(hr, msg) if(FAILED(hr)) throw COMException(hr, msg, __FILE__, __FUNCTION__, __LINE__)

class COMException
{
public:
	COMException(HRESULT hr, const string& msg, const string& file, const string& function, const int line)
	{
		_com_error error(hr);
		errorOutput = L"Msg: " + StringUtil::ToWideString(string(msg)) + L"\n";
		errorOutput += error.ErrorMessage();
		errorOutput += L"\nFile: " + StringUtil::ToWideString(file);
		errorOutput += L"\nFunction: " + StringUtil::ToWideString(function);
		errorOutput += L"\nLine: " + StringUtil::ToWideString(to_string(line));
	}
	const wchar_t* ErrorMsg() const
	{
		return errorOutput.c_str();
	}
private:
	std::wstring errorOutput;
};