#include <iostream>
#include <Mmdeviceapi.h>
#include "COMException.h"
#include <propvarutil.h>
#include <Functiondiscoverykeys_devpkey.h>

using namespace std;

const CLSID CLSID_MMDeviceEnumerator = __uuidof(MMDeviceEnumerator);
const IID IID_IMMDeviceEnumerator = __uuidof(IMMDeviceEnumerator);

IMMDeviceEnumerator* deviceEnumerator = nullptr;
IMMDeviceCollection* deviceCollection = nullptr;
IMMDevice* device = nullptr;
IPropertyStore* propertyStore = nullptr;

#define SafeRelease(ptr) if (ptr != nullptr) { ptr->Release(); ptr = nullptr; }

int main()
{
    ThrowIfFailed(CoInitialize(NULL), "");
    ThrowIfFailed(CoCreateInstance(CLSID_MMDeviceEnumerator, NULL, CLSCTX_ALL, IID_IMMDeviceEnumerator, (void**)&deviceEnumerator), "");
    ThrowIfFailed(deviceEnumerator->EnumAudioEndpoints(EDataFlow::eRender, DEVICE_STATE_ACTIVE, &deviceCollection), "");
    UINT deviceCount = 0;
    ThrowIfFailed(deviceCollection->GetCount(&deviceCount), "");
    cout << "Deivces Found: " << deviceCount << endl;
    for (UINT i = 0; i < deviceCount; i++)
    {
        ThrowIfFailed(deviceCollection->Item(i, &device), "");
        ThrowIfFailed(device->OpenPropertyStore(STGM_READ, &propertyStore), "");
        PROPVARIANT deviceNamePropVariant;
        PropVariantInit(&deviceNamePropVariant);
        ThrowIfFailed(propertyStore->GetValue(PKEY_Device_FriendlyName, &deviceNamePropVariant), "");
        WCHAR friendlyDeviceName[128];
        PropVariantToString(deviceNamePropVariant, friendlyDeviceName, 128);
        PropVariantClear(&deviceNamePropVariant);
        wcout << i << ":" << friendlyDeviceName << endl;
        SafeRelease(propertyStore);
        SafeRelease(device);
    }
    SafeRelease(deviceCollection);
    SafeRelease(deviceEnumerator);
    CoUninitialize();
    return 0;
}
